<template>
	<view class="page-main">
		<swiper v-if="newQuestionsAnswer.length > 0" class="swipercard" previous-margin="0" next-margin="0"
			:circular="false" :autoplay="false" :current="currentIndex" @change="eventHandle"
			:style="[{height: swiperHeight+ 'px'}]">
			<block v-for="(item, index) in newQuestionsAnswer" :key="index">
				<swiper-item class="swiperitem">
					<view class="itembox">
						<view class="box-hd">
							<view class="hdname">当前第<view class="text1">{{ index+ 1}}</view>道题</view>
							<view class="tt-time">{{time}}</view>
							<view class="hdnum">共{{totalNum}}道题</view>
						</view>
						<view class="contentbox">
							<view class="boxtitle">
								<text class="textl">{{index+1}}、</text>
								<block v-if="item.problemType == 'SINGLE' && item.originProblemType != 'jude'">
									<text class="textr">[单选题]({{item.score + `分`}}) {{item.title}}</text>
								</block>
								<block v-if="item.problemType == 'MULTY' && item.originProblemType != 'jude'">
									<text class="textr">[多选题]({{item.score + `分`}}) {{item.title}}</text>
								</block>
								<block v-if="item.problemType == 'SINGLE' && item.originProblemType == 'jude'">
									<text class="textr">[判断题]({{item.score + `分`}}) {{item.title}}</text>
								</block>
								<mp-html :content="item.secondTitle"></mp-html>
							</view>
							<view v-if="item.problemType == 'SINGLE'">

								<template v-for="(self,idxs) in item.children">
									<view @click="singChoose(index,idxs, item.problemType, item.originProblemType)" :key="idxs">
										<view class="boxbody option-select-item" v-if="self.isSelect">
											<view class="chooseitem">
												<!-- 	<image class="sinchoose-on" v-if="self.isSelect" :src="chooseonImg" mode="">
												</image> -->
												<view class="sinchoose"></view>
												<block v-if="item.isCorrect !== undefined">
													<view :class="item.isCorrect === 1  ? 'bodyr item-correct': 'bodyr item-error'">
														{{self.alias}}、{{self.answer}}
													</view>
												</block>
												<block v-else>
													<view class="bodyr">
														{{self.alias}}、{{self.answer}}
													</view>
												</block>
											</view>
										</view>
										<view class="boxbody" v-else>
											<view class="chooseitem">
												<!-- <image class="sinchoose-on" v-if="self.isSelect" :src="chooseonImg" mode="">
												</image> -->
												<view class="sinchoose"></view>
												<view class="bodyr">{{self.alias}}、{{self.answer}}</view>
											</view>
										</view>
									</view>
								</template>

							</view>
							<view v-if="item.problemType == 'MULTY'">

								<template v-for="(self,idxm) in item.children">
									<view :key="idxm" @click="multyChoose(index,idxm, item.problemType, item.originProblemType)">
										<!-- 选中状态开始 -->
										<view class="boxbody option-select-item" v-if="self.isSelect">
											<view class="chooseitem">
												<!-- <image class="sinchoose-on" :src="chooseonImg2" mode="">
										</image> -->
												<view class="sinchoose sinchoose2"></view>
												<block v-if="item.isCorrect !== undefined">
													<view :class="item.isCorrect === 1  ? 'bodyr item-correct': 'bodyr item-error'">
														{{self.alias}}、{{self.answer}}
													</view>
												</block>
												<block v-else>
													<view class="bodyr">
														{{self.alias}}、{{self.answer}}
													</view>
												</block>
											</view>
										</view>
										<!-- 选中状态结束 -->
										<!-- 未选中状态开始 -->
										<view class="boxbody" v-else>
											<view class="chooseitem">
												<!-- <image class="sinchoose-on" :src="chooseonImg2" mode="">
										</image> -->
												<view class="sinchoose sinchoose2"></view>
												<view class="bodyr">{{self.alias}}、{{self.answer}}</view>
											</view>
										</view>
										<!-- 未选中状态结束 -->
									</view>
								</template>

							</view>
							<view class="writeitem" v-if="item.problemType == 'QUESTION'">
								<textarea class="textInfo" v-model="item.userAnswer" @input="bindTextAreaBlur(index, item.problemType)"
									auto-height maxlength="200" placeholder="请输入您的答案" />
							</view>
						</view>

						<view class="footbtn">
							<view class="ftbtn1" @click="back(index)">上一题</view>
							<view class="ftbtn1" v-if="(index + 1) < totalNum" @click="next(index)">下一题</view>
							<view class="ftbtn2" v-else @click="submitData">提交</view>
						</view>
					</view>
				</swiper-item>

			</block>
		</swiper>
		<view class="" v-if="newQuestionsAnswer.length == 0">
			<view class="" style="padding: 15vh 20rpx;">
				<view class="tn-text-center" style="font-size: 200rpx;padding-top: 30rpx;">
					<text class="tn-icon-empty-page tn-color-gray--light"></text>
				</view>
				<view class="tn-color-gray--disabled tn-text-center tn-text-lg">试题正在努力添加中</view>
			</view>
		</view>

		<view class='tn-tabbar-height'></view>
		
		<!-- 底部导航开始 -->
		<view id="top-info" class="tn-footerfixed tn-safe-area-inset-bottom tn-bg-white"
			style="position: fixed;z-index: 999;bottom: 0;width: 100%;">
			<view class="tn-flex tn-flex-row-between tn-flex-col-center">
				<view class="tn-flex-2 justify-content-item">
					<view class="tn-flex tn-flex-row-center">
						<view class="tn-flex-1" @click="collect">
							<view class="tn-icon-like-break" style="font-size: 42rpx;"></view>
							<view class="tn-text-center tn-text-sm tn-padding-top-xs">收藏</view>
						</view>
						<view class="tn-flex-1 tn-padding-right-xl">
							<button class="tn-button--clear-style" style="border-radius: 0;" @click="showPopUp">
								<view class="tn-icon-menu-circle" style="font-size: 42rpx;"></view>
								<view class="tn-text-center tn-text-sm tn-padding-top-xs">答题卡</view>
							</button>
						</view>
					</view>
				</view>
				<view class="tn-flex-3 justify-content-item tn-padding-top-sm tn-padding-bottom-sm" style="text-align: center;">
					<!-- <tn-button shape="round" @click="showAnswerPopup" backgroundColor="#27B93A" padding="38rpx 0" width="40%"
						:fontSize="30">
						<text class="tn-color-white" hover-class="tn-hover" :hover-stay-time="150">
							试题答案
						</text>
					</tn-button> -->
					<tn-button shape="round" @click="submitData" backgroundColor="tn-main-gradient-blue" padding="38rpx 0"
						margin="0 0 0 30rpx" width="80%" :fontSize="30">
						<text class="tn-color-white" hover-class="tn-hover" :hover-stay-time="150">
							立即提交
						</text>
					</tn-button>
				</view>
			</view>
		</view>
		<!-- 底部导航结束 -->

		<!-- 答题卡开始 -->
		<view>
			<tn-popup mode="bottom" v-model="showpopup" height="50%">
				<view class="options">
						<block v-for="(item, index) in optionSelectStateItem">
							<view :key="index"  :class="item.isSelect !== undefined && item.isSelect ? 'option-item-select' : 'option-item'" @click="clickOption(index)">
								{{index + 1}}
							</view>
						</block>
				</view>
			</tn-popup>
		</view>
		<!-- 答题卡结束 -->

		<!-- 试题解析选项开始 -->
		<view>
			<tn-popup mode="bottom" v-model="showAnswer" close="closeShowAnswer">
				<view class="answers">
					<tn-list-cell :unlined="true" padding="1 0">你的答案：{{userAnswer}}</tn-list-cell>
					<tn-list-cell :unlined="true" padding="1 0">试题答案：{{optionAnswer}}</tn-list-cell>
					<tn-list-cell :unlined="true" padding="1 0">试题解析：<mp-html :content="analysis"></mp-html></tn-list-cell>
				</view>
			</tn-popup>
		</view>
		<!-- 试题解析选项结束 -->

	</view>
</template>

<script>
	export default {
		props: {
			//问题列表数据
			dataList: {
				type: Array,
				default () {
					return []
				}
			},
			// 是否显示答案
			popstate: {
				type: Boolean,
				default: false,
			},
			time: {
				type: String,
				default: '00:00:00'
			}
		},
		watch: {
			dataList: {
				deep: true,
				immediate: true,
				handler(newArr) {
					if (newArr.length) {
						this.newQuestionsAnswer = JSON.parse(JSON.stringify(newArr))
						this.totalNum = newArr.length
						this.setEmptyData()
						for (var i = 0; i < this.newQuestionsAnswer.length; i++) {
							this.optionSelectStateItem[i] = {
								isSelect: false
							}
						}
					}
				},
			}
		},
		data() {
			return {
				// topBanner: require('../../static/banner.png'),
				chooseonImg: require('../../static/chooseon.png'),
				chooseonImg2: require('../../static/chooseon2.png'),
				totalNum: 0,
				currentIndex: 0,
				newQuestionsAnswer: [],
				formSubmitData: [], //提交所需数据,
				swiperHeight: '',
				showpopup: false,
				showAnswer: false,
				userAnswer: '',
				optionAnswer: '',
				analysis: '',
				optionSelectStateItem: [],
			}
		},
		onShow() {
			this.getCurrentSwiperHeight('.itembox');
		},
		methods: {
			// 试题收藏
			collect() {
				this.$func.showToast("努力开发中")
			},
			// 显示答案弹窗
			showAnswerPopup() {
				if (this.popstate === false) {
					this.$func.showToast("答题模式无法查看答案")
					return
				}
				// 显示试题答案弹窗
				this.userAnswer = this.newQuestionsAnswer[this.currentIndex].userAnswer
				this.optionAnswer = this.newQuestionsAnswer[this.currentIndex].optionAnswer
				this.analysis = this.newQuestionsAnswer[this.currentIndex].analysis
				this.showAnswer = true
			},
			// 关闭答案弹窗
			closeShowAnswer() {
				this.showAnswer = false
			},
			// 点击选项卡
			clickOption(index) {
				this.currentIndex = index
				this.showpopup = false
			},
			// 显示选项卡
			showPopUp() {
				this.showpopup = true
			},
			// 获取内容高度
			getCurrentSwiperHeight(element) {
				let query = uni.createSelectorQuery().in(this);
				query.selectAll(element).boundingClientRect();
				query.exec((res) => {
					this.swiperHeight = 50 + res[0][this.currentIndex].height;
				})
			},
			//创建提交数组的数据结构
			setEmptyData() {
				this.newQuestionsAnswer.forEach((res) => {
					let userAnswer = ''
					res.children && res.children.forEach(item => {
						if (!item.isSelect) item.isSelect = 0
						else userAnswer = item
					})
					if (res.problemType == 'QUESTION') userAnswer = res.userAnswer
					this.formSubmitData.push({
						id: res.id, //题目id
						userAnswer: userAnswer, //答案
					})
				})
			},
			submitData() {
				if (this.popstate) {
					this.$func.showToast("该模式下无法提交")
					return
				}
				for (var i = 0; i < this.formSubmitData.length; i++) {
					if (!this.formSubmitData[i].userAnswer) {
						let toast = '请完成第' + (i + 1) + '题后提交！'
						uni.showToast({
							title: toast,
							icon: 'none'
						})
						this.currentIndex = i
						return
					}
				}
				this.$emit("submit", this.formSubmitData)
			},
			//单选事件
			singChoose(j, e, problemType, originProblemType) {
				if (this.newQuestionsAnswer[j].children[e].isSelect) {
					this.newQuestionsAnswer[j].children[e].isSelect = 0
					this.formSubmitData[j].userAnswer = ''
				} else {
					for (var i = 0; i < this.newQuestionsAnswer[j].children.length; i++) {
						if (this.newQuestionsAnswer[j].children[i].isSelect) {
							this.newQuestionsAnswer[j].children[i].isSelect = 0
						}
					}
					this.newQuestionsAnswer[j].children[e].isSelect = 1
					// 这块结合业务逻辑可以进行优化处理
					// 例如只保存用户已选择答案Id等
					this.formSubmitData[j].userAnswer = this.newQuestionsAnswer[j].children[e]
				}
				this.formSubmitData[j].problemType = problemType
				this.formSubmitData[j].originProblemType = originProblemType
				this.newQuestionsAnswer = JSON.parse(JSON.stringify(this.newQuestionsAnswer))
				this.optionSelectState()
			},
			//多选事件
			multyChoose(j, e, problemType, originProblemType) {
				this.newQuestionsAnswer[j].children[e].isSelect = this.newQuestionsAnswer[j].children[e].isSelect ^ 1
				let obj = []
				for (var i = 0; i < this.newQuestionsAnswer[j].children.length; i++) {
					console.log(this.newQuestionsAnswer[j].children[i].isSelect)
					if (this.newQuestionsAnswer[j].children[i].isSelect) {
						// 这块结合业务逻辑可以进行优化处理
						// 例如 只保存用户已选择答案Id等
						// obj.push(this.newQuestionsAnswer[j].children[i].id)
						obj.push(this.newQuestionsAnswer[j].children[i])
					}
				}
				this.formSubmitData[j].userAnswer = obj
				this.formSubmitData[j].problemType = problemType
				this.formSubmitData[j].originProblemType = originProblemType
				this.newQuestionsAnswer = JSON.parse(JSON.stringify(this.newQuestionsAnswer))
				this.optionSelectState()
			},
			// 处理选中和未选中的状态
			optionSelectState() {
				for (let i = 0; i < this.newQuestionsAnswer.length; i++) {
					for (let j = 0; j < this.newQuestionsAnswer[i].children.length; j++) {
						this.optionSelectStateItem[i] = {
							isSelect: false
						}
						if (this.newQuestionsAnswer[i].children[j].isSelect) {
							this.optionSelectStateItem[i].isSelect = true
							break;
						}
					}
				}
			},
			//富文本
			bindTextAreaBlur(index, problemType) {
				this.formSubmitData[index].problemType = problemType
				this.formSubmitData[index].userAnswer = this.newQuestionsAnswer[index].userAnswer
			},
			//swiper改变时
			eventHandle(e) {
				// 这块可以结合业务逻辑进行优化处理，如左右滑动切换题目时做一些提示处理等
				this.currentIndex = e.detail.current
				this.getCurrentSwiperHeight('.itembox');
			},
			// 上一题
			back(index) {
				if (!index) return
				this.currentIndex = index - 1
			},
			//下一题
			next(index) {
				this.currentIndex = index + 1
			}
		}
	};
</script>

<style scoped>
	/* 底部安全边距 start*/
	.tn-tabbar-height {
		min-height: 100rpx;
		height: calc(180rpx + env(safe-area-inset-bottom) / 2);
		height: calc(180rpx + constant(safe-area-inset-bottom));
	}
	
	.item-correct {
		color: #1DC069;
	}

	.item-error {
		color: #E83A30;
	}
	.tt-time {
		color: #01BEFF;
	}

	/* 选项卡开始 */
	.options {
		display: flex;
		flex-wrap: wrap;
		padding: 20rpx;
		padding-bottom: 10rpx;
		justify-content: flex-start;
	}

	.option-item {
		display: grid;
		place-items: center;
		width: 80rpx;
		height: 80rpx;
		border-radius: 50%;
		background-color: #E6E6E6;
		margin: 10rpx;
		color: #080808;
	}
	
	.option-item-select {
		display: grid;
		place-items: center;
		width: 80rpx;
		height: 80rpx;
		border-radius: 50%;
		background-color: #01BEFF;
		margin: 10rpx;
		color: #ffffff;
	}

	/* 选项卡结束 */

	.answers {
		padding-bottom: 100rpx;
	}

	/* 选项选中状态开始 */
	.option-select-item {
		/* background-color: #01BEFF !important; */
		/* border: 4rpx solid #01BEFF !important; */
		color: #0099ff !important;
		/* color: black !important; */
		border-radius: 6rpx !important;
	}

	/* 试题选中状态结束 */

	.page-main {
		width: 100%;
		/* height: 100vh; */
	}

	.topbox {
		width: 100%;
		height: 140rpx;
		position: relative;
		margin-top: 80rpx;
	}

	.topbox .imgtext {
		width: 100%;
		height: 100%;
		position: absolute;
		font-size: 36rpx;
		font-weight: normal;
		color: #FFFFFF;
		line-height: 36rpx;
		text-shadow: 0rpx 2rpx 4rpx rgba(0, 0, 0, 0.5);
	}

	.swipercard {
		width: 100%;
		height: calc(100vh - 16rpx);
		/* height: calc(100vh - 316rpx); */
		background: #FFFFFF;
	}

	.itembox {
		/* width: calc(100% - 96rpx); */
		padding: 32rpx 48rpx;
	}

	.box-hd {
		display: flex;
		justify-content: space-between;
		align-items: center;
		border-bottom: 4rpx dashed #f0f0f0;
		padding-bottom: 16rpx;
		/* padding-left: 16rpx; */
	}

	.hdname {
		font-size: 28rpx;
		display: flex;
		align-items: flex-start;
		font-weight: 500;
		color: #666666;
		line-height: 40rpx;
	}

	.text1 {
		color: #01BEFF;
		font-size: 40rpx;
		line-height: 32rpx;
	}

	.hdnum {
		font-size: 28rpx;
		font-weight: 400;
		color: #666666;
		line-height: 42rpx;
	}

	.contentbox {
		font-size: 32rpx;
		color: #333333;
		margin-top: 48rpx;
	}

	.boxtitle .textl {
		width: 50rpx;
		height: 34rpx;
		background: linear-gradient(90deg, #01BEFF 0%, #ffffff 100%);
	}

	.boxbody {
		padding-left: 26rpx;
		line-height: 64rpx;
		margin: 16rpx 0;
	}

	.chooseitem {
		display: flex;
		align-items: center;
		text-indent: -0.9em;
	}

	/* 试题选择框 */
	.sinchoose {
		/* width: 28rpx;
		height: 28rpx;
		margin-right: 4rpx;
		border-radius: 50%;
		background: #FFFFFF;
		border: 2rpx solid #BFBDBD; */
	}

	.sinchoose2 {
		border-radius: 6rpx;
	}

	/* 试题选中框 */
	.sinchoose-on {
		/* width: 28rpx;
		height: 28rpx;
		margin-right: 3rpx; */
	}

	.writeitem textarea {
		min-height: 164rpx;
		margin: 24rpx auto;
		padding: 16rpx;
		border: 2rpx solid #EBEBEB;
		border-radius: 4px;
		font-size: 30rpx;
		color: #333333;
	}

	.footbtn {
		display: flex;
		justify-content: space-between;
		margin-top: 50rpx;
		/* padding: 0 24rpx; */
	}

	.ftbtn1 {
		width: 270rpx;
		height: 80rpx;
		line-height: 80rpx;
		text-align: center;
		border: 2rpx solid #01BEFF;
		font-size: 30rpx;
		font-weight: 500;
		color: #01BEFF;
	}

	.ftbtn2 {
		width: 270rpx;
		height: 80rpx;
		line-height: 80rpx;
		text-align: center;
		background: #01BEFF;
		font-size: 30rpx;
		font-weight: 500;
		color: #FFFFFF;
	}
</style>